from flask import Flask, request, redirect, send_from_directory, abort
import sys
import mysql.connector
import base64
import string
import json
import secrets
import os
import time

app = Flask(__name__)

CONFIG = {
    'user': 'root',
    'password': 's2rYMCv3g2Gk',
    'host': 'db',
    'port': '3306',
    'database': 'notebook'
}

def getConnector():
    while(True):
        try:
            global CONFIG
            connection = mysql.connector.connect(**CONFIG)
            return connection
        except Exception as e:
            print(f'Failed with reason: {e}')
            print(f'Retrying in 5 second')
            time.sleep(5)


def init():
    connector = getConnector()
    cursor = connector.cursor()
    digits = string.digits
    password = ''.join(secrets.choice(digits) for i in range(16))
    cursor.execute(f"INSERT INTO users (username, password, publicnote, secretnote) VALUES ('{'Administrator'}','{password}','{'Welcome! I am admin and I hope you are having fun.'}', '{os.environ['FLAG']}') ON DUPLICATE KEY UPDATE password = '{password}';")
    connector.commit()
    cursor.close()
    connector.close()
    
def auth(token):
    username = base64.b64decode(token).decode().split(":")[0]
    password = base64.b64decode(token).decode().split(":")[1]
    connector = getConnector()
    cursor = connector.cursor(prepared=True)
    cursor.execute("SELECT username FROM users WHERE username = %s AND password = %s;", (username,password))
    results = cursor.fetchall()
    cursor.close()
    connector.close()
    if len(results) == 1 and results[0][0] == username:
        return username
    return None

def isInputValid(untrustedInput: str) -> bool:
    if "'" in untrustedInput \
        or "\"" in untrustedInput \
        or ";"  in untrustedInput \
        or "/"  in untrustedInput \
        or "*"  in untrustedInput \
        or "-"  in untrustedInput \
        or "#"  in untrustedInput \
        or "select"  in untrustedInput.lower() \
        or "insert"  in untrustedInput.lower() \
        or "update"  in untrustedInput.lower() \
        or "delete"  in untrustedInput.lower() \
        or "where"  in untrustedInput.lower() \
        or "union"  in untrustedInput.lower() \
        or "sleep"  in untrustedInput.lower() \
        or "secretnote"  in untrustedInput.lower() :
        return False
    return True


def doUpdatePublicNotes(content, username):
    connector = getConnector()
    cursor = connector.cursor(prepared=True)
    cursor.execute("UPDATE users SET publicnote = %s WHERE username = %s;", (content,username))
    connector.commit()
    cursor.close()
    connector.close()


def doSignUp(username,password):
    connector = getConnector()
    cursor = connector.cursor(prepared=True)
    cursor.execute("INSERT INTO users (username, password) VALUES (%s, %s);", (username,password))
    connector.commit()
    cursor.close()
    connector.close()

    
def doGetPublicNotes(column, ascending):
    connector = getConnector()
    cursor = connector.cursor()
    if column and not isInputValid(column):
        abort(403)
    if ascending  != "ASC":
        ascending = "DESC"
    cursor.execute(f"SELECT username, publicnote FROM users ORDER BY {column} {ascending};")
    results = []
    for row in cursor.fetchall():
        results.append({'username':row[0],
        'publicnote':row[1]})
    cursor.close()
    connector.close()
    return results

def doGetSecretNote(username):
    connector = getConnector()
    cursor = connector.cursor(prepared=True)
    cursor.execute("SELECT secretnote FROM users WHERE username = %s;", (username,))
    results = cursor.fetchall()[0][0]
    cursor.close()
    connector.close()
    return results

@app.route('/')
def root():
    return redirect("/index", code=302)

@app.route('/index')
def index():
    return send_from_directory('static', 'index.html')

@app.route('/home')
def home():
    return send_from_directory('static', 'home.html')

@app.route('/note',methods=['GET','POST'])
def note():
    token = request.cookies.get('token')
    username = auth(token)
    if(username == None):
        return 'Forbidden',403
    if request.method == 'GET':
        noteType = request.args.get('noteType')
        column = request.args.get("column")
        ascending = request.args.get("ascending")
        results = None
        if noteType == 'secret':
            results = doGetSecretNote(username)
        if noteType == 'public':
            results = doGetPublicNotes(column, ascending)
        return json.dumps({'content': results})
    if request.method == 'POST' and request.json:
        params = request.get_json()
        content = params['content']
        try:
            doUpdatePublicNotes(content,username)
            return 'OK',200
        except Exception as e:
            return f'Internal Error {e}',500

    return 'Bad Request',400

@app.route('/login',methods=['POST'])
def login():
    params = request.get_json()
    username = params["username"]
    password = params   ["password"]
    token = base64.b64encode(f"{username}:{password}".encode()).decode()
    username = auth(token)
    if(username == None):
        return 'Forbidden',403
    return 'OK',200

@app.route('/signup',methods=['POST'])
def signup():
    content_type = request.headers.get('Content-Type')
    if (content_type == 'application/json'):
        json = request.get_json()
    else:
        return 'Bad Request',400
    username = json["username"]
    password = json["password"]
    try:
        doSignUp(username,password)
    except Exception as e:
        return f'Internal Error {e}',500 
    return 'OK',200


if __name__ == '__main__':
    init()
    from waitress import serve
    serve(app, host="0.0.0.0", port=5000)
